Name:           cbmc
Version:        4.7
Release:        1%{?dist}
Summary:        Bounded Model Checker for ANSI-C and C++ programs

License:        BSD with advertising
URL:            http://www.cprover.org/cbmc/

# Upstream does not provide tarballs, but rather subversion release branches.
# Use the following commands to generate the tarball:
#  svn export http://www.cprover.org/svn/cbmc/releases/cbmc-%%{version}
#  tar cJvf cbmc-%%{version}.tar.xz cbmc-%%{version}
Source0:        %{name}-%{version}.tar.xz
# Fedora-specific patch: set up our build options
Patch0:         %{name}-4.7-fix-build.patch
# Fix breaking of strict aliasing rules.  Sent upstream 25 Jun 2014.
Patch1:         %{name}-4.7-alias.patch
# Fix the CUDD interface build.  Sent upstream 25 Jun 2014.
Patch2:         %{name}-4.7-cudd.patch

BuildRequires:  bison
BuildRequires:  cudd-devel
BuildRequires:  flex
BuildRequires:  minisat2-devel
BuildRequires:  tex(latex)
BuildRequires:  zlib-devel

%description
CBMC generates traces that demonstrate how an assertion can be violated, or
proves that the assertion cannot be violated within a given number of loop
iterations.

%prep
%setup -q
%patch0
%patch1
%patch2

# Use the right build flags
sed -e "s|@RPM_OPT_FLAGS@|$RPM_OPT_FLAGS|" \
    -e "s|@RPM_LD_FLAGS@|-Wl,--as-needed $RPM_LD_FLAGS|" \
    -i src/config.inc

%build
make %{?_smp_mflags} -C src

# Build the guide
pushd doc/guide
pdflatex CBMC-guide.tex
pdflatex CBMC-guide.tex
popd

%install
mkdir -p %{buildroot}%{_bindir} %{buildroot}%{_mandir}/man1
install -p -m 0755 src/cbmc/cbmc %{buildroot}%{_bindir}
install -p -m 0755 src/goto-cc/goto-cc %{buildroot}%{_bindir}
install -p -m 0755 src/goto-instrument/goto-instrument %{buildroot}%{_bindir}
install -p -m 0644 doc/man/cbmc.1 %{buildroot}%{_mandir}/man1

%check
cd regression
make

%files
%doc CHANGELOG LICENSE doc/guide/CBMC-guide.pdf doc/html-manual
%{_bindir}/cbmc
%{_bindir}/goto-cc
%{_bindir}/goto-instrument
%{_mandir}/man1/cbmc.*

%changelog
* Wed Jun 25 2014 Jerry James <loganjerry@gmail.com> - 4.7-1
- New upstream release
- Build with CUDD support

* Sun Dec  1 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.6-1.20131201svn
- Updated to upstream 4.6 release

* Tue Sep 10 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-7.20130515svn
- Fix build with unversioned docdir using _pkgdocdir (#992043)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.3-6.20130515svn
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 10 2013 Dan Horák <dan[at]danny.cz> - 4.3-5.20130515svn
- fix build on s390x

* Mon Jul  8 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-4.20130515svn
- Fixed changelog date

* Sun Jun 30 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-3.20130515svn
- Updated license
- Fixed doc and manual page directories

* Tue Jun 25 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-2.20130515svn
- Updated release

* Wed May 15 2013 Shakthi Kannan <shakthimaan [AT] fedoraproject.org> - 4.3-1.20130515svn
- First release
